      SUBROUTINE DOVAR
C
C     Deal with variables in file specifications for MAKESETUP.
C
      INCLUDE   'makeset.inc'
C
      INTEGER     IF, IL, JL, ICH, I1, IN, NC, LEN1, LENVAR, LENNAM
      INTEGER     ICS, ICQ, NFR, KL, ICE, IDUMP, JDUMP
      CHARACTER   VARNAM*40, VARVAL*80, FRONT*80, BACK*80
C ---------------------------------------------------------------------
C     Loop over files.
C
      DO IF = 1, NF
C
C        To avoid worrying about how many variables there are, 
C        deal with them one at a time.
C
C        Look for a variable.  If found, get name and value.
C        Use a GOTO loop since FILEL might change.
C
         IL = 0
  100    CONTINUE
            IL = IL + 1
            VARNAM = ' '
            ICH = INDEX( FILETEXT(IL,IF), '@' )
            IF( ICH .NE. 0 ) THEN
               CALL NXTWRD( FILETEXT(IL,IF), ICH+1, I1, IN )
               VARNAM = FILETEXT(IL,IF)(I1:IN)
               LENNAM = IN - I1 + 1
               NC = LEN1( FILETEXT(IL,IF) )
               IF( NC .EQ. IN ) THEN
                  VARVAL = ' '
                  LENVAR = 0
               ELSE
                  VARVAL = FILETEXT(IL,IF)(IN+2:NC)
                  LENVAR = NC - IN - 1
               END IF
C
C              Got a variable. 
C              Blank it out of the current line.
C              Then get rid of the current line if it is now blank.
C
               FILETEXT(IL,IF)(ICH:NC) = ' '
               IF( FILETEXT(IL,IF) .EQ. ' ' ) THEN
                  CALL SHIFT( FILETEXT(1,IF), ML, IL+1, FILEL(IF), -1 )
                  IL = IL - 1
               END IF
C
C              Now search through the the whole file and make
C              substitutions.  Substitute both where $VARNAM is 
C              seen and where ?varnam is seen.
C
               JL = 0
 200           CONTINUE
                  JL = JL + 1
                  ICS = INDEX( FILETEXT(JL,IF), '$'//VARNAM(1:LENNAM) )
                  NC = LEN1( FILETEXT(JL,IF) )
C
C                 Do a substitution.
C
                  IF( ICS .NE. 0 ) THEN
                     FRONT = ' '
                     NFR = 0
                     BACK = ' '
                     IF( ICS .GT. 1 ) THEN
                        FRONT = FILETEXT(JL,IF)(1:ICS-1)//' '
                        NFR = ICS - 1
                     END IF
                     IF( ICS + LENNAM  .LT. NC ) THEN
                        BACK = FILETEXT(JL,IF)(ICS+LENNAM+1:NC)
                     END IF
                     FILETEXT(JL,IF) = FRONT
                     FILETEXT(JL,IF)(1+NFR:80) = VARVAL
                     FILETEXT(JL,IF)(1+NFR+LENVAR:80) = BACK
                  END IF
C
C                 Delete some stuff if requested.
C
                  ICQ = INDEX( FILETEXT(JL,IF), '?'//VARNAM(1:LENNAM) )
                  IF( ICQ .NE. 0 ) THEN
                     IF( LENVAR .EQ. 0 ) THEN
C
C                       Look for the end of data to be omitted.
C
                        DO KL = JL, FILEL(IF)
                           ICE = INDEX( FILETEXT(KL,IF), '?end' )
                           IF( ICE .NE. 0 ) GO TO 300
                        END DO
                        WRITE(*,*) 'DOVAR: Omit region not ended.'
                        WRITE(*,*) FILE(IF)
                        STOP
C
  300                   CONTINUE
                        IF( JL .EQ. KL ) THEN
                           FILETEXT(JL,IF) = FILETEXT(JL,IF)(1:ICQ-1)
     1                       //FILETEXT(JL,IF)(ICE+1:80)
                        ELSE
                           IDUMP = JL
                           FILETEXT(JL,IF) = FILETEXT(JL,IF)(1:ICQ-1)
                           IF( LEN1( FILETEXT(JL,IF) ) .NE. 0 ) 
     1                         IDUMP = JL + 1
                           JDUMP = KL
                           FILETEXT(KL,IF) = FILETEXT(KL,IF)(ICE+4:80)
                           IF( LEN1( FILETEXT(KL,IF) ) .NE. 0 ) 
     1                         JDUMP = KL - 1
                           IF( JDUMP .GE. IDUMP ) THEN
                              CALL SHIFT( FILETEXT(1,IF), ML, JDUMP+1,
     1                            FILEL(IF), -(JDUMP - IDUMP + 1) )
                           END IF
                        END IF
C
                     ELSE
C
C                       Get rid of the ? specs if keeping the lines.
C
                        FILETEXT(JL,IF)(ICQ:ICQ+LENNAM) = ' '
                        IF( FILETEXT(JL,IF) .EQ. ' ' ) THEN
                           CALL SHIFT( FILETEXT(1,IF), ML, JL+1, 
     1                            FILEL(IF), -1 )
                        END IF
                        DO KL = JL, FILEL(IF)
                           ICE = INDEX( FILETEXT(KL,IF), '?end' )
                           IF( ICE .NE. 0 ) THEN
                              FILETEXT(KL,IF)(ICE:ICE+3) = ' '
                              IF( FILETEXT(KL,IF) .EQ. ' ' ) THEN
                              CALL SHIFT( FILETEXT(1,IF), ML, KL+1, 
     1                            FILEL(IF), -1 )
                              END IF
                              GO TO 400
                           END IF
                        END DO
                        WRITE(*,*) 'DOVAR: Omit region not ended.'
                        WRITE(*,*) FILE(IF)
                        STOP
C
  400                   CONTINUE
                        
                     END IF
                  END IF
                  IF( JL .LT. FILEL(IF) ) GO TO 200
C
            END IF
C
C           Go back for next line looking for definitions.
C
            IF( IL .LT. FILEL(IF) ) GO TO 100
C
C     Come here when done with this "file".    
C
      END DO
C
      RETURN
      END
      
