      SUBROUTINE SHIFT( TEXT, ML, L1, LN, NS )
C
C     Shift lines L1 to LN in TEXT by NS lines.  Vacated lines will
C     be left blank.  Be careful about overwrites.
C
C     LN will be assumed to be the total number of lines used in TEXT
C     and will be adjusted accordingly
C
      CHARACTER     TEXT(ML)*80
      INTEGER       ML, L1, LN, NS, JL
C ---------------------------------------------------------------------
C
      IF( LN + NS .GT. ML .OR. L1 + NS .LT. 1 ) THEN
C
C        Shift request will put lines outside the array.
C
         WRITE(*,*) 'SHIFT: Invalid shift request.', ML, L1, LN, NS
         STOP
      ELSE IF( NS .GT. 0 ) THEN
C
C        Shift lines forward and clear vacated ones at start.
C
         DO JL = LN, L1, -1
            TEXT(JL+NS) = TEXT(JL)
         END DO
         DO JL = L1, L1 + NS - 1
            TEXT(JL) = ' '
         END DO
      ELSE IF( NS .LT. 0 ) THEN
C
C        Shift lines beckwards and clear ones at end.
C
         DO JL = L1, LN
            TEXT(JL+NS) = TEXT(JL)
         END DO
         DO JL = LN + NS + 1, LN
            TEXT(JL) = ' '
         END DO
      ELSE 
C
C        NS = 0 => do nothing.
C
      END IF
C
C     Adjust the range of used lines, assuming LN is the last.
C
      LN = LN + NS
C
      RETURN
      END
